    program main
      use omp_lib
    
      implicit none
    
      integer :: max_threads, nthreads, tid
      integer :: neighb, c, i
      real(4), dimension(:), allocatable :: a, b
    
      max_threads = omp_get_max_threads()
    
      allocate(a(0:max_threads-1), b(0:max_threads-1))
    
      do i = 0,max_threads-1
        a(i) = real(i)
        b(i) = real(i)
      end do
    
      c = 3.0
    
      !$omp parallel private(tid, neighb, nthreads)
             tid = omp_get_thread_num()
        nthreads = omp_get_num_threads()
          neighb = tid - 1
    
      	if (tid .eq. 0) neighb = nthreads - 1
    
        a(tid) = a(tid) * 3.5
    
        !$omp barrier
    
        b(tid) = a(neighb) + c
      !$omp end parallel

      print *, a
      print *, b
    end program
