    program main
      use omp_lib

      implicit none

      integer, parameter :: n = 1000

      integer :: max_threads, i, tid, nthreads
      integer :: low, high
      integer, dimension(:), allocatable :: iterations

      max_threads = omp_get_max_threads()
      allocate(iterations(0:max_threads-1))

      iterations = 0

      !!$omp parallel private(tid)
        tid = omp_get_thread_num()

        !$omp do
          do i = 1,n
            iterations(tid) = iterations(tid) + 1
          end do
        !$omp end do
      !!$omp end parallel

      do i = 0, max_threads-1
        print 100, i, iterations(i)
100     format('Number of iteration for thread ', i0, ': ', i0)
      end do
    end program