    program main
      use omp_lib

      implicit none
    
      call omp_set_dynamic(.false.)
    
      !$omp parallel num_threads(2)
        call report_num_threads(1)
        !$omp parallel num_threads(2)
          call report_num_threads(2)
          !$omp parallel num_threads(2)
            call report_num_threads(3)
          !$omp end parallel
        !$omp end parallel
      !$omp end parallel
        
      contains
        subroutine report_num_threads(level)
          integer, intent(in) :: level
    
          integer :: nthreads
    
          nthreads = omp_get_num_threads()
    
          !$omp single
            print 100, level, nthreads
100         format('Level ', i0, ': the number of threads in the team is ', i0)
          !$omp end single
        end subroutine
    end program